/*****************************************************************
 File: m_lists.c
 Desc: list online zombies (guys with +z on usermode)
                   dccdenys (guys with usermode +v)
                   nojoin (+u usermode)

 Author: openglx@BrasNerd.com.br
 With code from: CoolMaster (CoolMaster@PTlink.net)
 Based in m_ircops.c by Lamego@PTlink.net

*/

#include "m_commands.h"
#include "client.h"
#include "channel.h"
#include "hash.h"
#include "struct.h"
#include "ircd.h"
#include "numeric.h"
#include "s_serv.h"
#include "send.h"
#include "m_silence.h"
#include "list.h"
#include "irc_string.h"
#include "s_conf.h"
#include "dconf_vars.h"

#include <string.h>     /* for strchr() */

int m_zombies(struct Client* cptr, struct Client* sptr, int parc, char* parv[])
{
  struct Client *acptr;
  char buf[BUFSIZE];
  int locals = 0;
  
  struct Client *lista;
  
  if (!IsAnOper(sptr))
    {
      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
      return 0;
    }  
  strcpy(buf, "\212StarByte\2 - Zombies (+z) List:");
  sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);

 /* why localopers should look lists from other servers?
  * there's no use to them know who is a zombie/etc on 
  * other servers.
  *  -- openglx
  */

  if (IsLocOp(sptr))
    lista = local_cptr_list;
  else  
    lista = GlobalClientList;
    
  for (acptr = lista; acptr; acptr = acptr->next)
	{
  	  if (IsZombie(acptr)) {
          if (!acptr->user) continue;
      ircsprintf(buf, "2\2%-23s\2 [%s@%s]", acptr->name ? acptr->name : "<unknown>",
                            acptr->username, acptr->host);
          sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
//          sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], "-");
          locals++;
    	}
    }
  ircsprintf(buf, "Total: \2%d\2 Zombie%s connected", locals, 
        (locals) > 1 ? "s" : "");
  sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
  sendto_one(sptr, form_str(RPL_ENDOFLISTS), me.name, parv[0], "/ZOMBIES");
  return 0;
}

int m_dccdenys(struct Client* cptr, struct Client* sptr, int parc, char* parv[])
{
  struct Client *acptr;
  struct Client *lista;
  char buf[BUFSIZE];
  int locals = 0;
  if (!IsAnOper(sptr))
    {
      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
      return 0;
    }  
  strcpy(buf, "\212StarByte\2 - DCC Deny (+v) List:");
  sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);

 /* why localopers should look lists from other servers?
  * there's no use to them know who is a zombie/etc on
  * other servers.
  *  -- openglx
  */
         
  if (IsLocOp(sptr))
    lista = local_cptr_list;
  else
    lista = GlobalClientList;
                     
  for (acptr = lista; acptr; acptr = acptr->next)
	{
  	  if (IsNoDCC(acptr)) {
          if (!acptr->user) continue;
      ircsprintf(buf, "2\2%-23s\2 [%s@%s]", acptr->name ? acptr->name : "<unknown>",
                            acptr->username, acptr->host);
          sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
//          sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], "-");
          locals++;
    	}
    }
  ircsprintf(buf, "Total: \2%d\2 connected", locals);
  sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
  sendto_one(sptr, form_str(RPL_ENDOFLISTS), me.name, parv[0], "/DCCDENYS");
  return 0;
}

int m_listnojoin(struct Client* cptr, struct Client* sptr, int parc, char* parv[])
{
  struct Client *acptr;
  struct Client *lista;
  char buf[BUFSIZE];
  int locals = 0;
  if (!IsAnOper(sptr))
    {
      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
      return 0;
    }  
  strcpy(buf, "\212StarByte\2 - NoJoin (+u) List:");
  sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
   /* why localopers should look lists from other servers?
    * there's no use to them know who is a zombie/etc on
    * other servers.
    *  -- openglx
    */
           
    if (IsLocOp(sptr))
      lista = local_cptr_list;
    else
      lista = GlobalClientList;
                       
  for (acptr = lista; acptr; acptr = acptr->next)
	{
  	  if (IsNojoin(acptr)) {
          if (!acptr->user) continue;
      ircsprintf(buf, "2\2%-23s\2 [%s@%s]", acptr->name ? acptr->name : "<unknown>",
                            acptr->username, acptr->host);
          sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
//          sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], "-");
          locals++;
    	}
    }
  ircsprintf(buf, "Total: \2%d\2 connected", locals);
  sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
  sendto_one(sptr, form_str(RPL_ENDOFLISTS), me.name, parv[0], "/NOJOINS");
  return 0;
}

int m_listabots(struct Client* cptr, struct Client* sptr, int parc, char* parv[])
{
  struct Client *acptr;
  struct Client *lista;
  char buf[BUFSIZE];
  int locals = 0;
  if (!IsAnOper(sptr))
  {
    sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
    return 0;
  }
  strcpy(buf, "\212StarByte\2 - BOT (+B) List:");
  sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
  
   /* why localopers should look lists from other servers?
    * there's no use to them know who is a zombie/etc on
    * other servers.
    *  -- openglx
    */
           
    if (IsLocOp(sptr))
      lista = local_cptr_list;
    else
      lista = GlobalClientList;                       
  
  for (acptr = lista; acptr; acptr = acptr->next)
  {
    if (IsBot(acptr)) {
      if (!acptr->user) continue;
      ircsprintf(buf, "2\2%-23s\2 [%s@%s]", acptr->name ? acptr->name : "<unknown>",
                 acptr->username, acptr->host);
      sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
//      sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], "-");
      locals++;
      }
      }
      ircsprintf(buf, "Total: \2%d\2 connected", locals);
  sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
  sendto_one(sptr, form_str(RPL_ENDOFLISTS), me.name, parv[0], "/BOTS");
  return 0;
}

