/*****************************************************************
 File: m_helpers.c
 Desc: list online helpers (guys with umode +h)
 Author: openglx@BrasNerd.com.br
 Based in m_ircops.c by Lamego@PTlink.net
*/

#include "m_commands.h"
#include "client.h"
#include "channel.h"
#include "hash.h"
#include "struct.h"
#include "ircd.h"
#include "numeric.h"
#include "s_serv.h"
#include "send.h"
#include "m_silence.h"
#include "list.h"
#include "irc_string.h"
#include "s_conf.h"
#include "dconf_vars.h"

#include <string.h>     /* for strchr() */

int m_helpers(struct Client* cptr, struct Client* sptr, int parc, char* parv[])
{
  struct Client *acptr;
  char buf[BUFSIZE];
  int locals = 0;

  if (MyConnect(sptr))
        sendto_ops_imodes(IMODE_SPY,
         "HELPERS requested by %s (%s@%s) [%s]",
         sptr->name, sptr->username,
         sptr->host, sptr->user->server);
                          

  strcpy(buf, "\212StarByte\2 - Online Helpers List:");
  sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
  for (acptr = GlobalClientList; acptr; acptr = acptr->next)
	{
  	  if (!IsService(acptr) && !IsStealth(acptr) && IsHelper(acptr) && !IsBot(acptr)) {
    
          if (!acptr->user) continue;

      ircsprintf(buf, "2\2%-23s\2 %-6s", acptr->name ? acptr->name : "<unknown>",
                            acptr->user->away ? "(AWAY)" : "");
      
          sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
          //sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], "-");
          locals++;
    	}
    }
 
  ircsprintf(buf, "Total: \2%d\2 Helper%s connected", locals, 
        (locals) > 1 ? "s" : "");
  sendto_one(sptr, form_str(RPL_LISTS), me.name, parv[0], buf);
  sendto_one(sptr, form_str(RPL_ENDOFLISTS), me.name, parv[0], "/HELPERS");
  return 0;
}

